#!/usr/bin/perl

use strict;
use lib qw(.);
use mconfig;

my $prgroot=mconfig::prgroot;
my $httpcmd=mconfig::httpcmd;
my $httpopt=mconfig::httpopt;
my $midplay=mconfig::rcpcmd;
my $midopt=mconfig::rcpopt;
my $mp3play=mconfig::mp3cmd;
my $mp3opt=mconfig::mp3opt;
if($mp3opt!~/\sfoo:/){
	$mp3play.=" ";
	$mp3play.=$mp3opt;
}
my $mp3list=mconfig::mp3list;
my $mp3jbls=mconfig::mp3jbls;
my $mp3jbox=mconfig::mp3jbox;
my @ext=mconfig::ext;

print "Content-type: text/html; charset=UTF-8\n\n";
print "<html>\n";
print "<head>\n";
print "<title>Music file Jukebox Play Page</title>\n";
print "</head>\n";
print "<body>\n";

if($ENV{'REQUEST_URI'} eq ""){
	print "<CENTER>\n";
	print "REQUEST_URI environment variable is required.<p>\n";
	print "</CENTER>\n";
	print "</body>\n";
	print "</html>\n";
	exit 1;
}

my ($name, $value, %param);
my ($cgipath, $qrystr) = split(/\?/, $ENV{'REQUEST_URI'});
$ENV{'QUERY_STRING'}=$qrystr if($ENV{'QUERY_STRING'} eq "");
my @qryary=split('&', $ENV{'QUERY_STRING'});
foreach my $var (@qryary){
	($name, $value)=split('=', $var);
	$param{$name}=$value;
}
my @cmdary=split(/\//, $0);
my $spltstr=$cmdary[$#cmdary];
my ($cgihead, $pathinfo)=split($spltstr, $cgipath);
$ENV{'SCRIPT_NAME'}=$cgihead.$spltstr if($ENV{'SCRIPT_NAME'} eq "");
$ENV{'PATH_INFO'}=$pathinfo if($ENV{'PATH_INFO'} eq "");

if((!-f "$prgroot/$httpcmd" && $^O eq "cygwin") || !-x "$prgroot/$httpcmd"){
	$cgipath=~s/$mp3jbox/$mp3list/;
	print "<center>\n";
	print "<a href=\"http://";
	print $param{'server_addr'}, $cgipath;
	print "\"><h2>Unsupported your environment!!</h2></a>\n";
	print "</center>\n";
	print "<hr>\n<p>\n";
	print $ENV{'SERVER_SIGNATURE'};
	print "</body>\n</html>\n";
	exit 1;
}
my $urlhead = "http://".$param{'server_addr'}.$ENV{'PATH_INFO'};
my $cnt=0;
my (@col, @url);
open HTTP, "$prgroot/$httpcmd $httpopt $urlhead |" or die;
while(my $line=<HTTP>){
	chomp($line);
	foreach my $edmy (@ext){
		$line=~s/\[\s{3}\]/\[SND\]/ if($line=~/\.$edmy/ && $line=~/\[   \]/);
	}
	@col=split(/\s+/, $line);
	if($col[1] eq "[SND]" || $col[1] eq "*"){
		$col[2]=~s/\[[0-9]+\]//g;
		if($col[2] ne "Parent"){
			$url[$cnt]=$urlhead."/".$col[2];
			$cnt++;
		}
	}
}
close HTTP;
$ENV{'SCRIPT_NAME'}=~s/$mp3jbox/$mp3jbls/;
print "<center>\n<h1><a href=\"http://$param{'http_host'}$ENV{'SCRIPT_NAME'}$ENV{'PATH_INFO'}?$ENV{'QUERY_STRING'}\">Return Jukebox List</a></h1>\n</center>\n";
print "<hr>\n";
print "</body>\n";
print "</html>\n";
print "<plaintext>\n";
my ($cmdall, $ret);
foreach my $fdmy (@url){
	print "filename: $fdmy\n";
	if($fdmy=~/\.mid$/i || $fdmy=~/\.rcp$/i || $fdmy=~/\.r36$/i){
		$cmdall="$prgroot/$midplay $midopt $fdmy";
		$ret=qx/$cmdall/;
		print "$ret\n";
	}
	elsif($fdmy=~/\.[a-z0-9]{3}$/i){
		$cmdall="$prgroot/$mp3play $fdmy";
		$ret=qx/$cmdall/;
		print "$ret\n";
	}
	else{
		print "\t$fdmy play skip.\n";
	}
}
exit 0;

