#!/usr/bin/perl

use strict;
use CGI;
use lib qw(.);
use config;
 
my $procomp=config::procomp;
my $profail=config::profail;

my $fname=$ENV{'PATH_TRANSLATED'};
$fname=~s/\/$//;
my ($rname, $newname, $oldname, $name, $value, $qrystr);
my (@rdname, @rfname, @qryary, %param);
read (STDIN, $qrystr, $ENV{'CONTENT_LENGTH'});
@qryary=split('&', $qrystr);
my ($ia, $ib, $ix)=(0, 0, 0);
foreach my $var (@qryary){
	($name, $value)=split('=', $var);
	if($name eq "rdname" && $value ne ""){
		$rdname[$ia]=$value;
		$ia++;
	}
	elsif($name eq "rfname" && $value ne ""){
		$rfname[$ib]=$value;
		$ib++;
	}
	else{
		$param{$name}=$value if($value ne "");
	}
}

$fname.="/";
if($param{'dname'} ne ""){
	$newname=$fname.$param{'dname'};
	mkdir ($newname, 0755);
}
if($param{'oname'} ne "" && $param{'nname'} ne ""){
	$oldname=$fname.$param{'oname'};
	$newname=$fname.$param{'nname'};
	rename $oldname, $newname;
}
if($ia>0){
	foreach my $dir (@rdname){
		$rname=$fname.$dir;
		rmdir $rname;
	}
}
if($ib>0){
	foreach my $file (@rfname){
		$rname=$fname.$file;
		unlink $rname;
	}
}
 
my $scrname=$ENV{'SCRIPT_NAME'};
my @scrary=split(/\//, $scrname);
my $requri=$ENV{'REQUEST_URI'};
$requri=~s/$scrary[$#scrary]/$procomp/;

print "Location:$requri\n\n";

